diff --git a/ChangeLog b/ChangeLog
index 3ce57a4f20..5be5c2fd95 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -10,6 +10,8 @@
   * Removed many redundant checks before RelinquishMagickMemory(),
     which is safe to call with a NULL argument.
   * Removed vpAg chunk write support (we are now writing caNv instead).
+  * coders/png.c: Initialized quantum_info to prevent memory leakage
+    (reference https://github.com/ImageMagick/ImageMagick/issues/582).
 
 2017-07-24  6.9.9-3 Cristy  <quetzlzacatenango@image...>
   * Release ImageMagick version 6.9.9-3, GIT revision 11809:2bd88257b:20170724.
diff --git a/coders/png.c b/coders/png.c
index 647bc270fe..662e9b61a4 100644
--- a/coders/png.c
+++ b/coders/png.c
@@ -2062,6 +2062,9 @@ static Image *ReadOnePNGImage(MngInfo *mng_info,
   Quantum
     *volatile quantum_scanline;
 
+  QuantumInfo
+    *volatile quantum_info;
+
   ssize_t
     j;
 
@@ -2216,6 +2219,7 @@ static Image *ReadOnePNGImage(MngInfo *mng_info,
 
   pixel_info=(MemoryInfo *) NULL;
   quantum_scanline = (Quantum *) NULL;
+  quantum_info = (QuantumInfo *) NULL;
 
   if (setjmp(png_jmpbuf(ping)))
     {
@@ -2229,6 +2233,8 @@ static Image *ReadOnePNGImage(MngInfo *mng_info,
 
       quantum_scanline=(Quantum *) RelinquishMagickMemory(quantum_scanline);
 
+      quantum_info=DestroyQuantumInfo(quantum_info);
+
 #ifdef IMPNG_SETJMP_NOT_THREAD_SAFE
       UnlockSemaphoreInfo(ping_semaphore);
 #endif
@@ -3201,9 +3207,6 @@ static Image *ReadOnePNGImage(MngInfo *mng_info,
 
   if (image->storage_class == DirectClass)
     {
-      QuantumInfo
-        *quantum_info;
-
       quantum_info=AcquireQuantumInfo(image_info,image);
 
       if (quantum_info == (QuantumInfo *) NULL)
